[![Build Status](https://img.shields.io/travis/WolfSoftware/punctuation_name/master.svg)](https://travis-ci.org/WolfSoftware/punctuation_name)
[![Software License](https://img.shields.io/badge/license-MIT-blue.svg)](LICENSE.md)
[![Release](https://img.shields.io/github/release/wolfsoftware/punctuation_name.svg)](https://github.com/wolfsoftware/punctuation_name/releases/latest)
[![Gem Version](https://badge.fury.io/rb/punctuation_name.svg)](https://badge.fury.io/rb/punctuation_name)
[![Github commits (since latest release)](https://img.shields.io/github/commits-since/wolfsoftware/punctuation_name/latest.svg)](https://github.com/wolfsoftware/punctuation_name/commits)
[![GitHub repo size in bytes](https://img.shields.io/github/repo-size/wolfsoftware/punctuation_name.svg)](https://github.com/wolfsoftware/punctuation_name)
[![GitHub contributors](https://img.shields.io/github/contributors/wolfsoftware/punctuation_name.svg)](https://github.com/wolfsoftware/punctuation_name)

# Punctuation Name

A ruby gem to display the name for any given punctuation. Comes with a UK and US dictionary but you can also pass custom dictionaries.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'punctuation_name'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install punctuation_name

## Usage

### Simple Usage

You can use the default built in dictionary which is UK/English.

```ruby
  require 'punctuation_name'

  puts PunctuationName::Punctuation.name('!')

  # or

  puts '!'.punctuation_name
```

### Extended Usage

You can also use the built-in US dictionary.

```ruby
  require 'punctuation_name'

  puts PunctuationName::Punctuation.name('!', 'us')

  # or

  puts '!'.punctuation_name('us')
```

### Advanced Usage

You can define your own dictionary, the below example just does a single item, but you can make the set as large as you need.

```
  require 'punctuation_name'

  PunctuationName::Punctuation.custom('custom', { '!' => 'shouty marker' })

  puts PunctuationName::Punctuation.name('!', 'custom')

  # or

  puts '!'.punctuation_name('custom')
```

## Return Value

The gem will return the name of the punctuation if it can be found in the selected dictionary, if not the original punctuation is returned.

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Testing

For local testing make sure that you run `bundle exec rspec spec` and then `rake install` to install the gem locally.

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/WolfSoftware/punctuation_name. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the PunctuationName project’s codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/WolfSoftware/punctuation_name/blob/master/CODE_OF_CONDUCT.md).
